-- This file contains the VHDL source code for the DIFF block of the FFE

--Library declaraions
library IEEE;
use IEEE.Std_logic_1164.ALL;

library COMPASS_LIB;
use COMPASS_LIB.COMPASS.ALL;
--compass compile_off
--use COMPASS_LIB.COMPASS_ETC.ALL;
--compass compile_on

entity diff is port (
   clk: in std_logic;
   reset: in std_logic; 
   Ri : in std_logic_vector(15 downto 0);
   Rq : in std_logic_vector(15 downto 0);
   Yi : in std_logic_vector(15 downto 0);
   Yq : in std_logic_vector(15 downto 0);
   Ei : out std_logic_vector(15 downto 0);
   Eq : out std_logic_vector(15 downto 0) );
end diff;

architecture behav of diff is 

 signal Ri_i : std_logic_vector(15 downto 0);
 signal Rq_i : std_logic_vector(15 downto 0);
 signal Yi_i : std_logic_vector(15 downto 0);
 signal Yq_i : std_logic_vector(15 downto 0);
 signal Ei_i : std_logic_vector(15 downto 0);
 signal Eq_i : std_logic_vector(15 downto 0);

begin

 Ei_i <= Ri_i - Yi_i;
 Eq_i <= Rq_i - Yq_i;
 
 process(clk,reset) 

  begin
    if reset = '0' then 
       Ri_i <="0000000000000000";
       Rq_i <="0000000000000000";
       Yi_i <="0000000000000000";
       Yq_i <="0000000000000000";
       Ei <= "0000000000000000";
       Eq <= "0000000000000000";

    elsif (clk'event and clk = '1') then 
        
       Ri_i <= Ri; 
       Rq_i <= Rq; 
       Yi_i <= Yi; 
       Yq_i <= Yq; 
       Ei <= Ei_i; 
       Eq <= Eq_i; 
   
    end if;

 end process;
end behav;
