-- This file contains the behavioral description of the FIR block used in the 
-- FFE

--Library declaraions
library IEEE;
use IEEE.Std_logic_1164.ALL;

library COMPASS_LIB;
use COMPASS_LIB.COMPASS.ALL;
--compass compile_off
--use COMPASS_LIB.COMPASS_ETC.ALL;
--compass compile_on

entity FIR is 
port (
  xin    : in std_logic_vector(7 downto 0);
  c0     : in std_logic_vector(7 downto 0);
  c1     : in std_logic_vector(7 downto 0);
  reset  : in std_logic; 
  clk    : in std_logic;
  yout   : out std_logic_vector(15 downto 0));
end fir;

architecture FIR of FIR is

signal x0 : std_logic_vector(7 downto 0);
signal x1 : std_logic_vector(7 downto 0);
signal p0 : std_logic_vector(15 downto 0);
signal p1 : std_logic_vector(15 downto 0);
signal y  : std_logic_vector(15 downto 0);

begin

 p0 <= c0 * x0;
 p1 <= c1 * x1; 
-- y <= p0 + p1;
 
reg: process(reset, clk) 

  begin
    if reset = '0' then 
       yout <= "0000000000000000";
       y   <= "0000000000000000";
       x1 <= "00000000";
       x0 <= "00000000";

    elsif clk'event and clk = '1' then 
       
       x0 <= xin;
       x1 <= x0;
       y <= p0 + p1;
       yout <= y;

    end if;
  end process;
end fir;
    
